//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  LimeGreen
#property  indicator_color2  LimeGreen
#property  indicator_color3  PaleVioletRed
#property  indicator_color4  PaleVioletRed
#property  indicator_color5  DarkSlateGray
#property  indicator_color6  Gold
#property  indicator_color7  DeepSkyBlue
#property  indicator_width1  2
#property  indicator_width4  2
#property  indicator_width6  2
#property  indicator_width7  2

//
//
//
//
//

extern int    Price             = PRICE_CLOSE;
extern double FastEMA           = 8.3896;
extern double SlowEMA           = 17.5185;
extern double SignalEMA         = 9.0503;
extern int    DpoPeriod         = 14;
extern int    DpoPrice          = PRICE_CLOSE;
extern double DpoMultiplier     = 0.25;
extern bool   drawMACD          = true;
extern bool   drawMACDHistogram = true;
extern bool   drawDpo           = true;

//
//
//
//
//

double Macd_buffer[];
double Sign_buffer[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double dpo[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);     SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2);     SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3);     SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4);     SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Macd_buffer);
   SetIndexBuffer(5,Sign_buffer);
   SetIndexBuffer(6,dpo);
      if (drawMACD==false && drawDpo==false) drawMACD = true;

   IndicatorShortName("MACD DiNapoli ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _emaf  0
#define _emas  1
#define _slope 2
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      int    DpoShift = DpoPeriod/2+1;
      double alphaf   = 2.0/(1.0+FastEMA);   
      double alphas   = 2.0/(1.0+SlowEMA);   
      double alphag   = 2.0/(1.0+SignalEMA);
      for(i = limit, r=Bars-i-1; i >= 0 ; i--,r++)
      {
         if (drawMACD)
         {
            double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            
               work[r][_emaf]  = work[r-1][_emaf]+alphaf*(price-work[r-1][_emaf]);
               work[r][_emas]  = work[r-1][_emas]+alphas*(price-work[r-1][_emas]);
               Macd_buffer[i]  = work[r][_emaf]-work[r][_emas];
               Sign_buffer[i]  = Sign_buffer[i+1]+alphag*(Macd_buffer[i]-Sign_buffer[i+1]);
               buffer1[i]      = EMPTY_VALUE;
               buffer2[i]      = EMPTY_VALUE;
               buffer3[i]      = EMPTY_VALUE;
               buffer4[i]      = EMPTY_VALUE;
               if (drawMACDHistogram)
               {
                  work[r][_slope] = work[r-1][_slope];
                  if (Macd_buffer[i]>Macd_buffer[i+1]) work[r][_slope] =  1;
                  if (Macd_buffer[i]<Macd_buffer[i+1]) work[r][_slope] = -1;
                  if (Macd_buffer[i]<0)
                  {
                     if (work[r][_slope]== 1) buffer3[i]=Macd_buffer[i];
                     if (work[r][_slope]==-1) buffer4[i]=Macd_buffer[i];
                  }
                  if(Macd_buffer[i]>0)
                  {
                     if (work[r][_slope]==-1) buffer2[i]=Macd_buffer[i];
                     if (work[r][_slope]== 1) buffer1[i]=Macd_buffer[i];
                  }
               }
            }                  
         if (drawDpo) dpo[i] = DpoMultiplier*(iMA(NULL,0,1,0,MODE_SMA,DpoPrice,i)-iMA(NULL,0,DpoPeriod,DpoShift,MODE_SMA,DpoPrice,i));
      }
   return(0);
}